searchNodes=[{"doc":"The purpose of Unplug is to provide a wrapper around any arbitrary plug, with the ability to conditionally execute that plug at run-time. The runtime conditions that are leveraged by Unplug must conform to the Unplug.Predicate behaviour. Out of the box Unplug comes with predicates that can be used to execute plugs based on: Environment variable values Application config values Request header values Request path values Unplug also preserves the behavior of Plug in that in its init/1 function it will evaluate the init/1 functions of your conditional plugs and store their values so that the call/2 function does not have to reevaluate the init/1 functions of your conditional plugs every time the plug pipeline is invoked (see the Plug docs for more information https://hexdocs.pm/plug/Plug.Builder.html#module-options). To use Unplug, add an entry in your endpoint.ex or router.ex files like so: plug Unplug, if: {Unplug.Predicates.RequestPathIn, [&quot;/metrics&quot;, &quot;healthcheck&quot;]} do: {Plug.Telemetry, event_prefix: [:phoenix, :endpoint]}","ref":"Unplug.html","title":"Unplug","type":"module"},{"doc":"This behaviour defines the structure of a module that can be used as an Unplug filter.","ref":"Unplug.Predicate.html","title":"Unplug.Predicate","type":"behaviour"},{"doc":"The call/1 function","ref":"Unplug.Predicate.html#c:call/2","title":"Unplug.Predicate.call/2","type":"callback"},{"doc":"Given an application and a key, execute the plug if the configured value matches the expected value. Usage: plug Unplug, if: {Unplug.Predicates.AppConfigEquals, {:my_app, :some_config, :enabled}}, do: MyApp.Plug","ref":"Unplug.Predicates.AppConfigEquals.html","title":"Unplug.Predicates.AppConfigEquals","type":"module"},{"doc":"Given an application and a key, execute the plug if the configured value is in the provided enumerable of values. Usage: plug Unplug, if: {Unplug.Predicates.AppConfigIn, {:my_app, :some_config, [:enabled, :enabled_again]}}, do: MyApp.Plug","ref":"Unplug.Predicates.AppConfigIn.html","title":"Unplug.Predicates.AppConfigIn","type":"module"},{"doc":"Given an application and a key, do not execute the plug if the configured value matches the expected value. Usage: plug Unplug, if: {Unplug.Predicates.AppConfigNotEquals, {:my_app, :some_config, :disabled}}, do: MyApp.Plug","ref":"Unplug.Predicates.AppConfigNotEquals.html","title":"Unplug.Predicates.AppConfigNotEquals","type":"module"},{"doc":"Given an application and a key, execute the plug if the configured value is not in the provided enumerable of values. Usage: plug Unplug, if: {Unplug.Predicates.AppConfigNotIn, {:my_app, :some_config, [:enabled, :enabled_again]}}, do: MyApp.Plug","ref":"Unplug.Predicates.AppConfigNotIn.html","title":"Unplug.Predicates.AppConfigNotIn","type":"module"},{"doc":"Given an environment variable, execute the plug if the configured value matches the expected value. Usage: plug Unplug, if: {Unplug.Predicates.EnvVarEquals, {&quot;ENABLE_DEBUG&quot;, &quot;true&quot;}}, do: MyApp.Plug","ref":"Unplug.Predicates.EnvVarEquals.html","title":"Unplug.Predicates.EnvVarEquals","type":"module"},{"doc":"Given an environment variable, execute the plug if the environment variable value is in the provided enumerable of values. Usage: plug Unplug, if: {Unplug.Predicates.EnvVarIn, {&quot;ENABLE_DEBUG&quot;, [&quot;true&quot;, &quot;1&quot;]}}, do: MyApp.Plug","ref":"Unplug.Predicates.EnvVarIn.html","title":"Unplug.Predicates.EnvVarIn","type":"module"},{"doc":"Given an environment variable, do not execute the plug if the configured value matches the expected value. Usage: plug Unplug, if: {Unplug.Predicates.EnvVarNotEquals, {&quot;ENABLE_DEBUG&quot;, &quot;false&quot;}}, do: MyApp.Plug","ref":"Unplug.Predicates.EnvVarNotEquals.html","title":"Unplug.Predicates.EnvVarNotEquals","type":"module"},{"doc":"Given an environment variable, execute the plug if the environment variable value is not in the provided enumerable of values. Usage: plug Unplug, if: {Unplug.Predicates.EnvVarNotIn, {&quot;ENABLE_DEBUG&quot;, [&quot;true&quot;, &quot;1&quot;]}}, do: MyApp.Plug","ref":"Unplug.Predicates.EnvVarNotIn.html","title":"Unplug.Predicates.EnvVarNotIn","type":"module"},{"doc":"Given a request header, execute the plug if the request value matches the expected value. Usage: plug Unplug, if: {Unplug.Predicates.RequestHeaderEquals, {&quot;authorization&quot;, &quot;super_secret&quot;}}, do: MyApp.Plug","ref":"Unplug.Predicates.RequestHeaderEquals.html","title":"Unplug.Predicates.RequestHeaderEquals","type":"module"},{"doc":"Given a request header, do not execute the plug if the request value matches the expected value. Usage: plug Unplug, if: {Unplug.Predicates.RequestHeaderNotEquals, {&quot;authorization&quot;, &quot;super_secret&quot;}}, do: MyApp.Plug","ref":"Unplug.Predicates.RequestHeaderNotEquals.html","title":"Unplug.Predicates.RequestHeaderNotEquals","type":"module"},{"doc":"Given a request path, execute the plug if the request value matches the expected value. Usage: plug Unplug, if: {Unplug.Predicates.RequestPathEquals, &quot;/metrics&quot;}, do: MyApp.Plug","ref":"Unplug.Predicates.RequestPathEquals.html","title":"Unplug.Predicates.RequestPathEquals","type":"module"},{"doc":"Given a request path, execute the plug if the request value is in the the provided enumerable of values. Usage: plug Unplug, if: {Unplug.Predicates.RequestPathIn, [&quot;/users&quot;, &quot;/auth&quot;]}, do: MyApp.Plug","ref":"Unplug.Predicates.RequestPathIn.html","title":"Unplug.Predicates.RequestPathIn","type":"module"},{"doc":"Given a request path, do not execute the plug if the request value matches the expected value. Usage: plug Unplug, if: {Unplug.Predicates.RequestPathNotEquals, &quot;/metrics&quot;}, do: MyApp.Plug","ref":"Unplug.Predicates.RequestPathNotEquals.html","title":"Unplug.Predicates.RequestPathNotEquals","type":"module"},{"doc":"Given a request path, do not execute the plug if the request value is in the the provided enumerable of values. Usage: plug Unplug, if: {Unplug.Predicates.RequestPathNotIn, [&quot;/metrics&quot;, &quot;/healthcheck&quot;]}, do: MyApp.Plug","ref":"Unplug.Predicates.RequestPathNotIn.html","title":"Unplug.Predicates.RequestPathNotIn","type":"module"},{"doc":"Unplug Unplug is an Elixir library that you can use to conditionally execute your plug modules at run-time in your Phoenix/Plug applications.","ref":"readme.html","title":"Unplug","type":"extras"},{"doc":"The package can be installed by adding :unplug to your list of dependencies in mix.exs: def deps do [ {:unplug, &quot;~&gt; 0.2.0&quot;} ] end After adding :unplug to your list of dependency, open up your config/dev.exs config file and add the following: ... config :unplug, :init_mode, :runtime ... This will make it so that your plug init/1 functions are not compiled for a quicker development experience and is in line with Phoenix and Plug conventions. With those in place, you are all set and ready to use Unplug","ref":"readme.html#installation","title":"Unplug - Installation","type":"extras"},{"doc":"Unplug can be used anywhere you would typically use the plug macro. For example, let&#39;s say you want to skip the Plug.Telemetry plug for certain routes (to cut down on noise in your logs for example). To do so, you would replace the following: plug Plug.Telemetry with the following: plug Unplug, if: {Unplug.Predicates.RequestPathNotIn, [&quot;/metrics&quot;, &quot;/healthcheck&quot;]}, do: {Plug.Telemetry, event_prefix: [:phoenix, :endpoint]} or with the following if no configuration is required of Plug.Telemetry: plug Unplug, if: {Unplug.Predicates.RequestPathNotIn, [&quot;/metrics&quot;, &quot;/healthcheck&quot;]}, do: Plug.Telemetry Let&#39;s break this down a bit so we can understand what is going on. Unplug takes a KeywordList of options that specifies how it will evaluate the request. The :if entry can be: A tuple with the first element being the predicate module and the second element being the options to send to the predicate (a predicate is a module that implements the Unplug.Predicate behavior). A module that implements the Unplug.Predicate behavior. Without any predicate options being specified, an empty list is sent as the second argument to the predicate&#39;s call/2 function. An anonymous function of arity one. That one argument being the conn for the current request. The :do entry can be: A tuple where the first element is the plug module that you want to execute upon a truthy value from the predicate, and the second element being options that you want to send to that plug. A plug module that you want to execute upon a truthy value from the predicate. Without any options specified, Unplug will assume that an empty list should be sent to the plug&#39;s init/1 function. An anonymous function that takes one argument, with that argument being the current request&#39;s conn. This function must also return a Plug.Conn struct. There is also an :else entry that can be provided to Unplug. The :else entry is identical to the :do entry in terms of what it accepts as valid input. The :else entry is what is execute if the :if entry yields a falsey value for the current request. Another example to show off the anonymous function and :else functionality could be something like this: plug Unplug, if: fn conn -&gt; conn.remote_ip == {10, 0, 0, 1} end, do: MyCoolApp.MetricsExporter, else: fn conn -&gt; Logger.warn(&quot;Someone is trying to steal my metrics!&quot;) conn end, If the above example, we only want to expose our Prometheus metrics if the request is coming from a known safe source (as a side note there are better ways to secure your metrics...don&#39;t use this in production).","ref":"readme.html#usage","title":"Unplug - Usage","type":"extras"},{"doc":"Unplug provides the following predicates out of the box: PredicateDescription Unplug.Predicates.AppConfigEqualsGiven an application and a key, execute the plug if the configured value matches the expected value Unplug.Predicates.AppConfigNotEqualsGiven an application and a key, do not execute the plug if the configured value matches the expected value Unplug.Predicates.AppConfigInGiven an application and a key, execute the plug if the configured value is in the provided enumerable of values Unplug.Predicates.AppConfigNotInGiven an application and a key, execute the plug if the configured value is not in the provided enumerable of values Unplug.Predicates.EnvVarEqualsGiven an environment variable, execute the plug if the configured value matches the expected value Unplug.Predicates.EnvVarNotEqualsGiven an environment variable, do not execute the plug if the configured value matches the expected value Unplug.Predicates.EnvVarInGiven an environment variable, execute the plug if the environment variable value is in the provided enumerable of values Unplug.Predicates.EnvVarNotInGiven an environment variable, execute the plug if the environment variable value is not in the provided enumerable of values Unplug.Predicates.RequestHeaderEqualsGiven a request header, execute the plug if the request value matches the expected value Unplug.Predicates.RequestHeaderNotEqualsGiven a request header, do not execute the plug if the request value matches the expected value Unplug.Predicates.RequestPathEqualsGiven a request path, execute the plug if the request value matches the expected value Unplug.Predicates.RequestPathNotEqualsGiven a request path, do not execute the plug if the request value matches the expected value Unplug.Predicates.RequestPathInGiven a request path, execute the plug if the request value is in the the provided enumerable of values Unplug.Predicates.RequestPathNotInGiven a request path, do not execute the plug if the request value is in the the provided enumerable of values","ref":"readme.html#provided-predicates","title":"Unplug - Provided Predicates","type":"extras"},{"doc":"To write your own Unplug predicate, all you have to do is implement the Unplug.Predicate behavior and provide a call/2 function that will return a boolean value. For example, if we wanted to have a plug conditionally execute only when the request method equals a certain value, we could create the following predicate module: defmodule MyApp.UnplugPredicates.MethodEquals do @behaviour Unplug.Predicate @impl true def call(%Plug.Conn{method: req_method}, opt_method), do: req_method == opt_method end and use it like so: plug Unplug, if: {MyApp.UnplugPredicates.MethodEquals, &quot;DELETE&quot;}, do: MyApp.MyPlugs.DeleteAuditLoggerPlug","ref":"readme.html#writing-your-own-predicates","title":"Unplug - Writing Your Own Predicates","type":"extras"}]